// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2022 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from TacPlusManager.idl.

package com.raritan.idl.auth;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface TacPlusManager_1_0_1 {
  static public final TypeInfo typeInfo = new TypeInfo("auth.TacPlusManager:1.0.1", null);

  public enum AuthenType {
    ASCII,
    PAP,
    CHAP,
    MSCHAP;
  }

  static public class ServerSettings implements Cloneable {
    public ServerSettings() {
      this.server = new String();
      this.port = new Integer(0);
      this.timeoutSeconds = new Integer(0);
      this.retries = new Integer(0);
      this.sharedSecret = new String();
      this.authenType = com.raritan.idl.auth.TacPlusManager_1_0_1.AuthenType.values()[0];
      this.disableAccounting = new Boolean(false);
    }

    public Object clone() {
      ServerSettings copy = new ServerSettings();

      copy.server = this.server;
      copy.port = this.port;
      copy.timeoutSeconds = this.timeoutSeconds;
      copy.retries = this.retries;
      copy.sharedSecret = this.sharedSecret;
      copy.authenType = this.authenType;
      copy.disableAccounting = this.disableAccounting;

      return copy;
    }

    public String server;
    public int port;
    public int timeoutSeconds;
    public int retries;
    public String sharedSecret;
    public com.raritan.idl.auth.TacPlusManager_1_0_1.AuthenType authenType;
    public boolean disableAccounting;
  }

  public static final int ERR_INVALID_CFG = 1;

  public static final int ERR_SERVER_UNSPECIFIED = 2;

  public static final int ERR_INVALID_SHARED_SECRET = 3;

  public static final int ERR_SERVER_UNREACHABLE = 4;

  public static final int ERR_AUTHENTICATION_FAILED = 5;

  public static final int ERR_NO_ROLES = 6;

  public static final int ERR_NO_KNOWN_ROLES = 7;

  public class GetTacPlusServersResult {
    public java.util.List<com.raritan.idl.auth.TacPlusManager_1_0_1.ServerSettings> _ret_;
  }

  GetTacPlusServersResult getTacPlusServers() throws Exception;

  AsyncRequest getTacPlusServers(AsyncRpcResponse<GetTacPlusServersResult> rsp);

  AsyncRequest getTacPlusServers(AsyncRpcResponse<GetTacPlusServersResult> rsp, RpcCtrl rpcCtrl);


  public class SetTacPlusServersResult {
    public int _ret_;
  }

  SetTacPlusServersResult setTacPlusServers(java.util.List<com.raritan.idl.auth.TacPlusManager_1_0_1.ServerSettings> serverList) throws Exception;

  AsyncRequest setTacPlusServers(java.util.List<com.raritan.idl.auth.TacPlusManager_1_0_1.ServerSettings> serverList, AsyncRpcResponse<SetTacPlusServersResult> rsp);

  AsyncRequest setTacPlusServers(java.util.List<com.raritan.idl.auth.TacPlusManager_1_0_1.ServerSettings> serverList, AsyncRpcResponse<SetTacPlusServersResult> rsp, RpcCtrl rpcCtrl);


  public class TestTacPlusServerResult {
    public int _ret_;
  }

  TestTacPlusServerResult testTacPlusServer(String username, String password, com.raritan.idl.auth.TacPlusManager_1_0_1.ServerSettings settings) throws Exception;

  AsyncRequest testTacPlusServer(String username, String password, com.raritan.idl.auth.TacPlusManager_1_0_1.ServerSettings settings, AsyncRpcResponse<TestTacPlusServerResult> rsp);

  AsyncRequest testTacPlusServer(String username, String password, com.raritan.idl.auth.TacPlusManager_1_0_1.ServerSettings settings, AsyncRpcResponse<TestTacPlusServerResult> rsp, RpcCtrl rpcCtrl);

}
